library ieee;
use ieee.std_logic_1164.all;
library dataio;
use dataio.STD_LOGIC_OPS."+";

entity accum is
    port(reset,clk, ld:  in std_logic;
         datain:         in std_logic_vector(3 downto 0);
         out1:           out std_logic_vector(3 downto 0));
end;

architecture behavioral of accum is
    signal accum_q:   std_logic_vector(3 downto 0);

begin
   process (reset, clk)
   begin
	if (reset ='1') then
		accum_q <= "0000";
	else
		if (clk ='1' and clk'event) then
	    		if (ld='1') then
				accum_q <= datain;
	    		else
  		                accum_q <= datain + accum_q;
	    		end if;
		end if;
	end if;
    end process;

    out1 <= accum_q;
end;

