-- conflits
-- conflit.vhd

package resolution is
   type x_0_1 is ('x','0','1') ;
   type x_0_1_vector is array(natural range <>) of x_0_1 ;
   function to_x_0_1(e : bit) return x_0_1 ;
   function collision(e : x_0_1_vector) return x_0_1 ;
   subtype res_x_0_1 is collision x_0_1 ;
end package resolution ;

package body resolution  is
   function to_x_0_1(e : bit) return x_0_1 is
   begin
      if e = '0' then return '0' ; 
      else return '1' ;
      end if ;
   end to_x_0_1 ;

   function collision(e : x_0_1_vector) return x_0_1 is
      variable valeur : x_0_1 := 'x' ;
   begin
      if e'length > 0 then
         valeur := e(e'left) ;
         for i in e'range loop
            if valeur /= e(i) then 
               valeur := 'x' ;
            end if ;
         end loop ;
      end if ;
      return valeur ;
   end collision ;
end package body resolution ;

entity conflit is
end conflit ;

use work.resolution.all ;

architecture exemple of conflit is
   signal a,b : bit := '0' ;
   signal s : res_x_0_1 ;
begin
   s <= to_x_0_1(a) ;
   s <= to_x_0_1(b) ;
   a <= '1' after 10 ns,'0' after 20 ns, '1' after 30 ns ;
   b <= '1' after 20 ns ;
end exemple ;
