-- dcodeur 74138
-- dec74138.vhd

entity dec_74_138 is
   port ( A, B, C, G1, G2A, G2B : in bit ;
          O : out bit_vector (0 to 7) );
end dec_74_138 ;

architecture table of dec_74_138 is
type table_dec is array(bit,bit,bit) of bit_vector(0 to 7) ;
constant decode : table_dec  :=
       ((("01111111",    --000
          "10111111"),   --001
         ("11011111",    --010
          "11101111")),  --011
        (("11110111",    --100
          "11111011"),   --101
         ("11111101",    --110
          "11111110"))); --111
signal valid : boolean ;
begin
valid <= (G1 and not G2A and not G2B) = '1' ;
O <= decode(C,B,A) when valid else (others => '1') ;
end table ;

architecture equations of dec_74_138 is
signal valid : bit ;
begin
valid <= G1 and not G2A and not G2B ;
O(0) <= not (valid and not A and not B and not C ) ;
O(1) <= not (valid and     A and not B and not C ) ;
O(2) <= not (valid and not A and     B and not C ) ;
O(3) <= not (valid and     A and     B and not C ) ;
O(4) <= not (valid and not A and not B and     C ) ;
O(5) <= not (valid and     A and not B and     C ) ;
O(6) <= not (valid and not A and     B and     C ) ;
O(7) <= not (valid and     A and     B and     C ) ;
end equations ;

architecture flot of dec_74_138 is
signal valid : bit ;
subtype val_ad is bit_vector(0 to 3) ;
begin
valid <= G1 and not G2A and not G2B ;
with val_ad'(valid & a & b & c) select
   O <= "01111111" when "1000",
        "10111111" when "1100",
        "11011111" when "1010",
        "11101111" when "1110",
        "11110111" when "1001",
        "11111011" when "1101",
        "11111101" when "1011",
        "11111110" when "1111",
        "11111111" when others ;
end flot ;

architecture comporte of dec_74_138 is
begin
decode : process (A, B, C, G1, G2A, G2B)
   variable valid : boolean ;
   subtype adresse is bit_vector(0 to 2) ;
begin
   valid := (G1 and not G2A and not G2B) = '1' ;
   if not valid then
      O <= (others => '1' ) ;
   else
      case adresse'(A & B & C) is
         when "000" => O <= "01111111" ;
         when "100" => O <= "10111111" ;
         when "010" => O <= "11011111" ;
         when "110" => O <= "11101111" ;
         when "001" => O <= "11110111" ;
         when "101" => O <= "11111011" ;
         when "011" => O <= "11111101" ;
         when "111" => O <= "11111110" ;
      end case ;
   end if ;
end process decode ;
end comporte ;

library ieee ;
use ieee.numeric_bit.all ;

architecture calcule of dec_74_138 is
begin
decode : process (A, B, C, G1, G2A, G2B)
   variable valid : boolean ;
   variable index : integer range 0 to 7 ;
begin
   valid := (G1 and not G2A and not G2B) = '1' ;
   index := to_integer(unsigned'(C & B & A)) ;
   O <= (others => '1') ;
   if valid then
      O(index) <= '0' ;
   end if ;
end process decode ;
end calcule ;
