
-- description d'une decade d'un compteur decimal synchrone.
-- decade.vhd


LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.all ;
--
ENTITY decade IS 
	PORT   (clk : in    std_logic;
		en,raz   : in std_logic;
		count: out std_logic_vector (3 downto 0);
		dix  : out std_logic);
END decade;


ARCHITECTURE behavior OF decade IS
   signal count_temp : integer range 0 to 9 ;
begin
   count <= std_logic_vector --(3 downto 0)
           (to_unsigned(count_temp,4)) ;
   dix <= en when count_temp = 9 else '0';
   decimal : PROCESS
      BEGIN
      WAIT UNTIL rising_edge(clk ) ;
      if (raz = '1') then
			count_temp <= 0 ;
		elsif (en = '1') then
			count_temp <= (count_temp + 1) mod 10 ;  
		end if ;
   END process decimal ;
END behavior ; 




