-- feu_fonc.vhd
-- exemple fonctionnel non synthtisable

--entity feux is
--	port (	detect : in bit ;
--		Rp, Op, Vp, Rs, Os, Vs : out bit );
--end feux ;

architecture vue_esprit of feux is
	type etat_feu is (defaut, prior, sort1, 
		sort2, second, retour1, retour2);
	constant T10 : time := 10 sec ;
	constant T30 : time := 30 sec ;
	constant T60 : time := 60 sec ;

	signal automate : etat_feu ;
begin

sorties : process 
begin
	Rp <= '0' ; Op <= '0' ; Vp <= '0' ;
	Rs <= '0' ; Os <= '0' ; Vs <= '0' ;
	case automate is
		when defaut  => Vp <= '1' ; Rs <= '1' ;
		when sort1   => Op <= '1' ; Rs <= '1' ;
		when sort2   => Rp <= '1' ; Rs <= '1' ;
		when second  => Rp <= '1' ; Vs <= '1' ;
		when retour1 => Rp <= '1' ; Os <= '1' ;
		when retour2 => Rp <= '1' ; Rs <= '1' ;
		when prior   => Vp <= '1' ; Rs <= '1' ;
	end case ;
	wait on automate ;
end process sorties ;

sequence : process 
begin
	case automate is
		when defaut  => if detect = '0' then
				wait until detect = '1' ;
			end if ;
				automate <= sort1 ;
				wait on automate ;
		when sort1   => wait for T10 ;
				automate <= sort2  ; 
				wait on automate ; 
		when sort2   => wait for T10 ;
				automate <= second ; 
				wait on automate ;
		when second  => wait for T30 ;
				automate <= retour1; 
				wait on automate ;
		when retour1 =>	wait for T10 ;
				automate <= retour2; 
				wait on automate ;
		when retour2 => wait for T10 ;
				automate <= prior  ; 
				wait on automate ;
		when prior   => wait for T60 ;
				automate <= defaut ; 
				wait on automate ;
	end case ;
end process sequence ;
end vue_esprit ;