-- feu_synt.vhd
-- exemple synthtisable

entity feux is
	port (	hor, detect : in bit ;
		Rp, Op, Vp, Rs, Os, Vs : out bit );
end feux ;

architecture synthese of feux is
	type etat_feu is (defaut, prior, sort1, 
		sort2, second, retour1, retour2);
	signal T10, T30, T60 : bit ;
	signal temps : integer range 0 to 129 ;
	signal automate : etat_feu ;
begin

sorties : process 
begin
	Rp <= '0' ; Op <= '0' ; Vp <= '0' ;
	Rs <= '0' ; Os <= '0' ; Vs <= '0' ;
	case automate is
		when defaut  => Vp <= '1' ; Rs <= '1' ;
		when sort1   => Op <= '1' ; Rs <= '1' ;
		when sort2   => Rp <= '1' ; Rs <= '1' ;
		when second  => Rp <= '1' ; Vs <= '1' ;
		when retour1 => Rp <= '1' ; Os <= '1' ;
		when retour2 => Rp <= '1' ; Rs <= '1' ;
		when prior   => Vp <= '1' ; Rs <= '1' ;
	end case ;
	wait on temps ;
end process sorties ;

sequence : process 
begin
	wait until hor = '1' ;
	case automate is
		when defaut  => if detect = '1' then
				automate <= sort1 ;
				end if ;
		when sort1   => if T10 = '1' then
				automate <= sort2  ; 
				end if ; 
		when sort2   => if T10 = '1' then
				automate <= second ; 
				end if ;
		when second  => if T30 = '1' then
				automate <= retour1; 
				end if ;
		when retour1 =>	if T10 = '1' then
				automate <= retour2; 
				end if ;
		when retour2 => if T10 = '1' then
				automate <= prior  ; 
				end if ;
		when prior   => if T60 = '1' then
				automate <= defaut ; 
				end if ;
	end case ;
end process sequence ;

tempo : process
begin
	wait until hor = '1' ;
	if automate = defaut or temps = 129 then
		temps <= 0 ;
	else
		temps <= temps + 1 ;
	end if ;
end process tempo ;

calcul_Ti : process 
begin
	T10 <= '0' ; T30 <= '0' ; T60 <= '0' ;
	case temps is
		when 9   => T10 <= '1' ;
		when 19  => T10 <= '1' ;
		when 49  => T30 <= '1' ;
		when 59  => T10 <= '1' ;
		when 69  => T10 <= '1' ;
		when 129 => T60 <= '1' ;
		when others => null ;
	end case ;
	wait on temps ;
end process calcul_Ti ;

end synthese ;