-- procdures de traitement du temps
-- temporel.vhd

library ieee ;
use ieee.std_logic_1164.all ;

package temporel is
   procedure propagat (signal sortie : out std_logic ;
                       variable nouvelle : in std_logic ;
                       variable ancienne : inout std_logic ;
                       constant tlh,thl : in time) ;
   procedure test_regles(constant nom : in string ;
                         signal clk : in std_logic ;
                         signal entree : in std_logic ;
                         variable clk_front, entree_change : inout time ;
                         constant tsu ,th : in time ;
                         variable ras : out boolean) ;
end package temporel ;

package body temporel is
   procedure propagat (signal sortie : out std_logic ;
                       variable nouvelle : in std_logic ;
                       variable ancienne : inout std_logic ;
                       constant tlh,thl : in time) is                     
   begin
      case std_logic_vector'(ancienne,nouvelle) is
         when "00" | "11" => return ;
         when "01" | "X1" => sortie <= nouvelle after tlh ;
                             ancienne := nouvelle ;
         when "10" | "X0" => sortie <= nouvelle after thl ;
                             ancienne := nouvelle ;
         when others => sortie <= 'X' ;
                        ancienne := 'X' ;
      end case ;
   end procedure propagat ;

   procedure test_regles(constant nom : in string ;
                         signal clk : in std_logic ;
                         signal entree : in std_logic ;
                         variable clk_front, entree_change : inout time ;
                         constant tsu ,th : in time ;
                         variable ras : out boolean) is
   begin
   if now = 0 ns then
      clk_front := 0 ns ;
      entree_change := 0 ns ;
      return ;
   end if ;
   ras := true ;
   if entree'event then
      if rising_edge(clk) then
         clk_front := now ;
      end if ;
      if now - clk_front < th then
         report nom & " : violation de thold" ;
         ras := false ;
      end if ;
      entree_change := now ;
   elsif rising_edge(clk) then
      if now - entree_change < tsu then
         report nom & " : violation de set up" ;
         ras := false ;
      end if ;
      clk_front := now ;
   elsif clk'event and (clk = '1' or clk'last_value = '0') then
      report nom & " : transition d'horloge illgale" ;
      ras := false ;
   end if ;
   end procedure test_regles ;
end package body temporel ;

