-- trois tats
-- troiseta.vhd

package troisetats is
   type x_0_1_z is ('x','0','1','z') ;
   type x_0_1_z_vector is array(natural range <>) of x_0_1_z ;
   function to_x_0_1_z(e : bit) return x_0_1_z ;
   function resoudre(e : x_0_1_z_vector) return x_0_1_z ;
   subtype res_x_0_1_z is resoudre x_0_1_z ;
end package troisetats ;

package body troisetats  is
   function to_x_0_1_z(e : bit) return x_0_1_z is
   begin
      if e = '0' then return '0' ; 
      else return '1' ;
      end if ;
   end to_x_0_1_z ;
   
   type x_0_1_z_table is array(x_0_1_z, x_0_1_z) OF x_0_1_z ;
   constant resolution_table : x_0_1_z_table := (
--      --------------------------------
--      |  x    0    1    z        |   |  
--      --------------------------------
        ( 'x', 'x', 'x', 'x' ), -- | x |
        ( 'x', '0', 'x', '0' ), -- | 0 |
        ( 'x', 'x', '1', '1' ), -- | 1 |
        ( 'x', '0', '1', 'z' )  -- | z |
        );
        
   function resoudre(e : x_0_1_z_vector) return x_0_1_z is
      variable valeur : x_0_1_z := 'z' ;
   begin
      if e'length = 1 then
         valeur := e(e'left) ;
      else
         for i in e'range loop
            valeur := resolution_table(valeur, e(i));
         end loop ;
      end if ;
      return valeur ;
   end resoudre ;
end package body troisetats ;

entity test_troiset is end test_troiset ;

use work.troisetats.all ;

architecture exemple of test_troiset is
   signal a, b, oea, oeb : bit := '0' ;
   signal s : res_x_0_1_z ;
begin
   s <= to_x_0_1_z(a) when oea = '0' else 'z' ;
   s <= to_x_0_1_z(b) when oeb = '0' else 'z' ;
   a <= '1' after 10 ns,'0' after 20 ns, '1' after 30 ns ;
   b <= '1' after 20 ns ;
   process(oea)
   begin
      oea <= not oea after 5 ns ;
   end process ;
   oeb <= not oea after 2 ns ;
end exemple ;
