-- detection de trois zeros, 3 bascules, sortie anticipee
-- tz_meal3.vhd

entity trois_zero is
	port ( hor, din : in bit ;
                  tzero : out bit ) ;
end trois_zero ;

architecture mealy3 of trois_zero is
constant aucun     : bit_vector(2 downto 0) := "000" ;
constant unzero    : bit_vector(2 downto 0) := "001" ;
constant deuxzero  : bit_vector(2 downto 0) := "010" ;
constant troiszero : bit_vector(2 downto 0) := "100" ;
signal etat, futur : bit_vector(2 downto 0) ;
begin
tzero <= futur(2) ;
evolution : process
begin
	wait until hor = '1' ;
		etat <= futur ;
end process evolution ;

transitions : process(din, etat)
begin
	if din = '1' then
		futur <= aucun ;
	else
		case etat is
			when aucun 	=> futur <= unzero ;
			when unzero 	=> futur <= deuxzero ;
			when deuxzero 	=> futur <= troiszero ;
			when troiszero 	=> futur <= unzero ;
			when others	=> futur <= aucun ;
		end case ;
	end if ;
end process transitions ;
end mealy3 ;


