-- detection de trois zeros successifs, code one hot, type 
-- tz_mohot.vhd

entity trois_zero is
   port ( hor, din : in bit ;
          tzero : out bit ) ;
end trois_zero ;

architecture moore2 of trois_zero is
--type code is (one_hot_one,one_hot_zero) ; --warp
--attribute state_encoding : code ; --warp
--attribute enum_encoding : string ;--synario
   type machine4 is (aucun, trois, un, deux) ;
attribute state_encoding of machine4 :type is one_hot_one ;--warp
--attribute enum_encoding of machine4 :type is "one hot" ; --synario
   signal etat : machine4 ;
begin
tzero <= '1' when etat = trois else '0' ;-- sortie
std : process
begin
   wait until hor = '1' ;
   if din = '1' then
      etat <= aucun ;
   else
      case etat is
         when aucun => etat <= un ;
         when un    => etat <= deux ;
         when deux  => etat <= trois ;
         when trois => etat <= un ;
      end case ;
   end if ;
end process std ;
end moore2 ;

-- State encoding (sequential) for 'etat' is:
--	aucun :=	b"00";
--	troiszero :=	b"01";
--	unzero :=	b"10";
--	deuxzero :=	b"11";

--    tzero =  /etatSBV_0.Q * etatSBV_1.Q 

--    etatSBV_1.D =  etatSBV_0.Q * /din 

--    etatSBV_0.D = /etatSBV_1.Q * /din 
--                + /etatSBV_0.Q * /din 



