-- detection de trois zeros, 3 bascules, sortie retardee directe
-- tz_moor3.vhd

entity trois_zero is
	port (	hor, din : in bit ;
		tzero : out bit ) ;
end trois_zero ;

architecture moore3 of trois_zero is
constant aucun     : bit_vector(2 downto 0) := "000" ;
constant unzero    : bit_vector(2 downto 0) := "001" ;
constant deuxzero  : bit_vector(2 downto 0) := "010" ;
constant troiszero : bit_vector(2 downto 0) := "100" ;
signal etat : bit_vector(2 downto 0) ;
begin
tzero <= etat(2) ;
std : process
begin
	wait until hor = '1' ;
	if din = '1' then
		etat <= aucun ;
	else
		case etat is
			when aucun 	=> etat <= unzero ;
			when unzero 	=> etat <= deuxzero ;
			when deuxzero 	=> etat <= troiszero ;
			when troiszero 	=> etat <= unzero ;
			when others	=> etat <= aucun ;
		end case ;
	end if ;
end process std ;
end moore3 ;


--    tzero.D  = /din * /tzero.Q * etat_1.Q * /etat_0.Q 

--    tzero.C  = hor 

--    etat_1.D = /din * /tzero.Q * /etat_1.Q * etat_0.Q 

--    etat_1.C = hor 

--    etat_0.D = /din * /etat_1.Q * /etat_0.Q 

--    etat_0.C = hor 


